<?php
$errmessage = array();
if( $_POST ){
	// POST情報がある時の処理
	// 1. 入力チェック
  if( !$_POST['e'] ) {
	  $errmessage[] = "Eメールを入力してください";
  } else if( strlen($_POST['e']) > 200 ){
	  $errmessage[] = "Eメールは200文字以内にしてください";
  } else if( !filter_var($_POST['e'], FILTER_VALIDATE_EMAIL) ){
	  $errmessage[] = "メールアドレスが不正です";
  }

	if( !$_POST['p'] ) {
		$errmessage[] = "パスワードを入力してください";
	} else if( strlen($_POST['p']) > 100 ){
		$errmessage[] = "パスワードは100文字以内にしてください";
	}

  if( $_POST['p'] != $_POST['p2'] ) {
	  $errmessage[] = "確認用パスワードが一致しません";
  }

	// 2. 新規ユーザー登録処理
	$userfile = '../userinfo.txt';
  if( !$errmessage ) {
	  $ph   = password_hash( $_POST['p'], PASSWORD_DEFAULT );
	  $line = '"' . $_POST['e'] . '","' . $ph . '"' . "\n";
	  $ret  = file_put_contents( $userfile, $line, FILE_APPEND );
  }

	// 3. ログイン画面にリダイレクトする
  if( !$errmessage ){
    $host  = $_SERVER['HTTP_HOST'];
    $uri   = rtrim(dirname($_SERVER['PHP_SELF']), '/\\');
    header("Location: //$host$uri/login.php");
    exit;
  }

} else {
	// POST情報がない時の処理(GETのとき)
	$_POST['e'] = '';
}
?>
<!DOCTYPE html>
<html lang="ja">
<head>
  <meta charset="utf-8">
  <title>新規登録</title>
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/css/bootstrap.min.css" integrity="sha384-9aIt2nRpC12Uk9gS9baDl411NQApFmC26EwAOH8WgZl5MYYxFfc+NcPb1dKGj7Sk" crossorigin="anonymous">
  <style>
    div.button{
      text-align: center;
    }
  </style>
</head>
<body>
<div class="container">
  <div class="mx-auto" style="width:400px;">
    <h1>ユーザー新規登録</h1>
	  <?php
      if( $errmessage ){
        echo '<div class="alert alert-danger" role="alert">';
        echo implode('<br>', $errmessage );
        echo '</div>';
      }
	  ?>
    <form action="./register.php" method="post">
      Eメール<input type="email" name="e" value="<?php echo htmlspecialchars($_POST['e']) ?>" class="form-control"><br>
      パスワード<input type="password" name="p" value="" class="form-control"><br>
      パスワード(確認)<input type="password" name="p2" value="" class="form-control"><br>
      <div class="button">
        <input type="submit" name="register" value="登録" class="btn btn-primary btn-lg">
      </div>
    </form>
  </div>
</div>
</body>
</html>


